#BREAKING LOOPS AND Pedigree extension up to tree graph via coping 
#of some persons (loop.pl)
#Part 1: Selecting Loop Breakers in General Pedigrees (loop_edge.exe)
#Part 2: Breaking Loops, Pedigree Extension and Persons Renumeration (loop_ext.exe)
# (c) 2005 T. Axenovich
# last modified 1.02.2005

# use "loop.pl --help"  for details
#-------------------------- help message begins -----------------


$help_message="

CONTROL LINE:
loop.pl input_pedigree_file input_cost_file output_pedigree_file

where: 

1. Input_pedigree_file may be named arbitrary. The file must contain columns 
with pedigree ID (ped), personal ID (id), father's ID (fa), mother's ID (mo), 
sex, and original ID (orig_id) defined for every person. The file must have a 
header line, which should contain abovementioned keywords. There may be more 
columns in the input file, these are just ignored. This is a typical output 
from our pedigree verification and recoding programm, RECODE_PED. In this file,
ids are coded as integers from 1 to total number of people in the sample. The 
parents come before offspring. The sexes are coded as '1' for male and '2' for 
female. orig_id contains original person name or id. It is a text value. 
Separator may be defined as comma or tab or space. 
2. Input_cost_file may be named arbitrary. The file consists of three columns: 
odered IDs of breaker and his/her spouse and cost function. The file has not a 
header line.

OUTPUT FILE: may be named arbitrary. If comand line has not name of this file,
it is named ped_new.dat. The file has usual pedigree file structure: pedigree 
ID (ped), personal ID (id), father's ID (fa), mother's ID (mo), proband status 
(prob), sex, and original ID (orig_id) defined for every person.

SEE readme_loop.doc for details.


";
#-------------------------- help message ends -----------------

#***** get command line arguments**************
#**** (names of file pedigree, costs and output pedigree file) *****

die "run loop.pl --help for details\n" if (@ARGV<1);

if ($ARGV[0] eq "--help") {
	print "${help_message}";
#shoud be replaced with soft end!
	die ""; 
}; 

$ouped='ped_new.dat';

if (@ARGV>=2)   {
		$inped=$ARGV[0] ;
		$incost=$ARGV[1];
		$ouped=$ARGV[2] if @ARGV==3;
 }
else	{die "ERROR of comand line\n";
 }



unlink 'task.inp'; ## delete task file 

open (OTASK,">task.inp");

print (OTASK "$inped\n$incost\n$ouped\n");

close OTASK;
	
print " IDENTIFICATION OF LOOP BREAKERS\n";
($sec,$min,$hour,$mday,$mon,$year)=localtime;
print "${hour}:${min}:${sec}\n";
print " WAITING\n";
system("loop_edge.exe");
print " PEDIGREE EXTENTION\n";
($sec,$min,$hour,$mday,$mon,$year)=localtime;
print "${hour}:${min}:${sec}\n";

system("loop_ext.exe");
($sec,$min,$hour,$mday,$mon,$year)=localtime;
print "${hour}:${min}:${sec}\n";

unlink 'res.dat';
#unlink 'task.inp'; ## delete files 

