
 	     program EDGES_FOR_COST !>>>>
C	POTENTIAL BREAKERS LIST for WEIGHT estimation >>>

	Character*20 name_ped,name_list
	character*80 ccc
	include 'par.incl'
	include 'mass.incl'
	dimension luk(N_SIZE)


C	READING of NAMES of initial data  files
C	There are two files of initial data: pedigree data (integer:PED,ID,FA,MO,
C     		SEX;character:KOD) and list of phenotyped persons (integer:ID,1)
	open (unit=1, file='task_w.inp')
	read (1,*)name_ped
	read (1,*)name_list
	close (unit=1)

C	READING of pedigree data (mas and kod)
	open (unit=1,file=name_ped)
	read (1,*) ccc
	i=0
311	i=i+1
	read (1,*,end=312)(mas(i,j),j=1,5)  
       if (mas(i,2).ne.i) then !^^^
         print 102,i,mas(i,2)  !^^^
	pause
102	 format (///'Individuals are not recoded sequentially ',
     *           'or the file not sorted'/
     *           ' Check row ',i8,' and individual ',i8)
	end if

	ndat=i !!!sample size
	goto 311
312	close (unit=1)
C	READING and correction of list data (+ 1 for PEDIG FORMAT) !^^^
	open (unit=1,file=name_list)
	i=0
711	i=i+1
	read (1,*,end=712)liste(i,1)  
	nlist=i !!!list size
	liste(i,2)=1
	goto 711
712	close (unit=1)

	name_list='list_new.dat'
	open (unit=1,file='list_new.dat')
	do i=1,nlist
	write(1,*)(liste(i,j),j=1,2)
	end do
	close (unit=1)


	iage=22
	open(unit=1,file='ped_ped.dat')
	do i=1,ndat
	write(1,*)(mas(i,j),j=2,4),iage,mas(i,5)
	end do
	close (unit=1)
c        print *,'ped_ped writing'
	open (unit=1,file='task_w_fin.inp')
	write(1,*)ndat
	write(1,*)name_list
	close(1)


C	Test of declared sample size
	if (ndat.gt.N_SIZE)then
	print *,'ndat>N_SIZE:',ndat,N_SIZE
	stop
	end if

C	Massiv INS (cumulative sizes of families)

	do i=1,N_FAM
	ins(i)=0
	end do

	do 666 i=1,ndat
	ins(mas(i,1)+2)=ins(mas(i,1)+2)+1
666	continue

	n=0
	i=0
667	i=i+1
        n=n+ins(i+2)
	ins(i+2)=ins(i+1)+ins(i+2)
	if (n.lt.ndat)goto 667

	ins(1)=i
c	print *,'INS:',(ins(kk),kk=1,i+2)
c	pause

C	Test of declared number of families
	if (i+1.gt.N_FAM)then
	print *,'nfam>N_FAM:',i,N_FAM
	stop
	end if

C	PEDIGREE CYCLE
c	Program works with each	pedigree separately
	open (unit=2,file='edge.dat')
	nstar=0
	do 1001 is=1,ins(1)

	ls0=ins(is+1)
	ls1=ls0+1
	ls2=ins(is+2)
	lss=ls2-ls0
	if (lss.eq.0)goto 1001


C	STRUCTURE OF DATA:

	CALL structure(is)
	if (npar.eq.0)goto 1001              !^^^

C	SOWING of unlooped parts of pedigree
	ip=npar

c	print *,' call sow'
	call SOW_TREE(is) 

C	EDGES FORMATION
	call EDGE(is)                 	

1001	continue

	close(unit=2)
	stop
	end


	subroutine SOW_TREE(is)
C	**************************************************
C	SOWING of tree-structures (NP with one connected person and 
C	some unmarried offspring)
c	RESULT: Number of NP and size of mas are decreased
	include 'par.incl'
	include 'mass.incl'
	dimension luk(N_SIZE),mm(M_PAIR)


	ls0=ins(is+1)	                        	
	ls1=ls0+1
	ls2=ins(is+2)
	lss=ls2-ls0

	do i=1,npar
	luk(i)=0
	end do

111	kk=0
	do 14 ip=1,npar

	if (luk(ip).eq.1)goto 14
	k_mar=0     ! number of married offspring in IP
	k_sum=0     ! number of offspring in IP
	do i=1,M_PAIR
	mm(i)=0
	end do

C	For every nuclear pedigree (NP) number of offspring (k_sum) and
C	number of married ones (k_mar) are summerized
C	If k_sum=1 and both parents are single married ancestors, they are eliminated
C	If there are married and unmarried offspring in the NP, all unmarried 
C		offspring are eliminated
C	If all offspring are unmarried, all without one of them are eliminated
	k=0
	do 12 i=ls1,ls2
	if (mas(i,1).ne.ip) goto 12
	mmm=mas(i,2)
	k_sum=k_sum+1
	k=k+1
	if (nspou(mmm).ne.0)then
	k_mar=k_mar+1
	mm(k)=1
	end if
12	continue
 
	ih=0

	if (k_mar.eq.0)goto 24 ! all offspring are unmarried
	if(k_mar.eq.k_sum)goto 324 !all offspring are married

C	There are married and unmarried offspring in the NP
	ll=0
	do 19 i=ls1,ls2
	if (mas(i,1).ne.ip) goto 19
	ll=ll+1
	if (mm(ll).eq.0)then
c	print *,'obrezka visjachih 1: IP=',ip,mas(i,2)
	mas(i,1)=0 ! obrezka visjachih
	kk=kk+1
	ih=1
	end if
19	continue

	goto 524

C	all offspring are unmarried
C	ostavljaem odnogo potomka

24	l=0
	do 145 i=ls1,ls2
	if (mas(i,1).ne.ip) goto 145
	if (l.eq.0)then
	l=l+1
	goto 145
	else
c	print *,'obrezka visjachih 2: IP=',ip,mas(i,2)
	mas(i,1)=0
	kk=kk+1
	ih=1
	end if
145	continue

c	correction of massive ipair
524     if (ih.eq.0)goto 324
	l=0
	do 545 i=ls1,ls2
	if (mas(i,1).ne.ip) goto 545
	l=l+1
	ipair(ip,l+3)=mas(i,2)
545	continue
	ipair(ip,3)=l
	k_sum=l
c	print *,'CORR:', ip,(ipair(ip,i),i=1,l+3)

324		if (k_sum.ne.1)goto 14
	m0=ipair(ip,4) ! ID of a single offspring
	m1=ipair(ip,1)
	m2=ipair(ip,2)
	mp1=mas(m1,3)+nspou(m1)-1
	mp2=mas(m2,3)+nspou(m2)-1
	if (mp1.ne.0.and.mp2.ne.0) goto 14
	if (mp1.eq.0.and.mp2.eq.0)then
	
C	both parents are single married ancestors
	mas(m1,1)=0
	mas(m2,1)=0
	nspou(m1)=nspou(m1)-1
	nspou(m2)=nspou(m2)-1
	goto 15
	end if
	
C	one parent is single married ancestor	
	if (nspou(m0).ne.0)goto 14
	if (mp1.ne.0) goto 811
	mas(m1,1)=0
	mp1=0
	nspou(m2)=nspou(m2)-1

	goto 15
811	mas(m2,1)=0
	nspou(m1)=nspou(m1)-1
	goto 15

c	pair elimination
15	luk(ip)=1
	do i1=ls1,ls2
	if(mas(i1,1).eq.ip)then
	mas(i1,1)=0
	mas(i1,3)=0
	mas(i1,4)=0
	end if
	end do
	kk=kk+1
14	continue
	if (kk.ne.0)goto 111

C	NEW massiv ipair
	ip=0
888	ip=ip+1
	k=0
	do 814 i=ls1,ls2
	if (mas(i,1).eq.0)goto 814
	if (k.ne.0) goto 815
	ipair(ip,1)=mas(i,3)
	ipair(ip,2)=mas(i,4)
	ipair(ip,3)=1
	ipair(ip,4)=mas(i,2)
	np=mas(i,1)
	mas(i,1)=0
	k=1
	goto 814
815	if (mas(i,1).ne.np)goto 814
	ipair(ip,3)=ipair(ip,3)+1
	ipair(ip,ipair(ip,3)+3)=mas(i,2)
	mas(i,1)=0
814	continue
	if (k.gt.0) goto 888

	npar=ip-1  ! FINAL NUMBER OF NP
	print *,npar,' of them are in loops'!^^^
	return
	end

	subroutine EDGE(is)
C	*****************************************
c	EDGEs FORMATION
	include 'par.incl'
	include 'mass.incl'

c	>>>>>>>>>>>>>>>>>>>
	do i=1,npar
	m1=ipair(i,1)
	m2=ipair(i,2)
c	print *,i,m1,m2
	if (nspou(m1).le.1.and.mas(m1,3).eq.0)goto 100
	write(2,*)m1,m2
	nstar=nstar+1
100	if (nspou(m2).le.1.and.mas(m2,3).eq.0)goto 200
	write(2,*)m2,m1
	nstar=nstar+1
200	end do
ccc	pause
c	>>>>>>>>>>>>>>>>>>>>>>>>>
c	print *, 'nstar=', nstar

	return
	end

	subroutine STRUCTURE(is)
C	*****************************************
C	STRUCTURE OF DATA:
c	print*,'STRUCTURE OF DATA'
	include 'par.incl'
	include 'mass.incl'

	ls0=ins(is+1)
	ls1=ls0+1
	ls2=ins(is+2)
	lss=ls2-ls0
	if (lss.eq.0)return

C	SET of COUPLES
c		ipair(massiv of pairs)
c		ipair(i,1)=father's ID
c		ipair(i,2)=mother's ID
c		ipair(i,3)=number of offspring
c		ipair(i,4-n)= ID's of offspring
	do i=1,lss
	do j=1,M_PAIR
	ipair(i,j)=0
	end do
	end do
	max_pair=0
C	Parents and the set of offspring for every pair is found and written in
C		massiv ipair() 

	do i=ls1,ls2
	mas(i,1)=0
	end do

	ip=0
111	ip=ip+1
	ip1=0
	ip2=0

	k=0
	do i=ls1,ls2
	if(mas(i,1).eq.0.and.mas(i,3).ne.0)then
	if (ip1.eq.0) then
	ip1=mas(i,3)
	ip2=mas(i,4)
	mas(i,1)=ip
	k=k+1
	ipair(ip,k+3)=mas(i,2)
	else
	if (mas(i,3).eq.ip1.and.mas(i,4).eq.ip2)then
	mas(i,1)=ip
	k=k+1
	ipair(ip,k+3)=mas(i,2)
	end if
	end if
	end if
	end do	
	if (k.eq.0) goto 115
	if (k.gt.max_pair)max_pair=k
	ipair(ip,1)=ip1
	ipair(ip,2)=ip2
	ipair(ip,3)=k
	goto 111
115	ip=ip-1

C	Test of declared m_pair
	if (max_pair+3.gt.M_PAIR) then
	print *,'Increase M_PAIR in par.incl to',
     *	max_pair+5,' and recompile EDGE.for'!^^^^
	stop
	end if

	do i=ls1,ls2
	m0=mas(i,2)
	isex=mas(i,5)
	k=0
	do j=1,ip
	if (ipair(j,isex).eq.m0)k=k+1
	end do
	nspou(i)=k
	end do

	npar=ip 
	if (npar.gt.0)print *,'pedigree=',is,' contains',npar,' 
     *	nuclear families'!^^^
	return
	end

